#Region EXEMPLE
#include <array.au3>

Global Enum $UNIQUES, $DOUBLONS
Global Const $AVEC_SEPARATEURS = True
Global Const $SANS_SEPARATEURS = False

Global $c = "11,1,111,11,1,111,1111,1,1,1,11"

; supprime les doublons
MsgBox(0, $c, remplace_uniques_doublons($c))

; rcupre les lments uniques
$aResultat = recupere_uniques_doublons($c)
_ArrayDisplay($aResultat)

$c = "11,  1,  111,  11,  1,  111,  1111,  1,  1,  1,  11"

; met tous les doublons entre crochets et leur sparateur entre parenthses
MsgBox(0, $c, remplace_uniques_doublons( _
		$c, _ ; chane
		",  ", _ ; sparateurs (virgule et 2 espaces)
		"\d+", _ ; contenu  chercher (chiffres
		"[\d, ]+", _ ; contenu prsent dans la chane (chiffres, virgules, espaces)
		$DOUBLONS, _ ; type  chercher
		$AVEC_SEPARATEURS, _ ; inclure les sparateurs ?
		"[\1](\2)", _ ; chane de remplacement
		0)) ; nombre de remplacements

; met tous les lments uniques entre crochets et leur sparateur entre parenthses
; (ATTENTION : cette fois, \1 contient le sparateur et \2 contient l'lment !!)
MsgBox(0, $c, remplace_uniques_doublons( _
		$c, _
		",  ", _
		"\d+", _
		"[\d, ]+", _
		$UNIQUES, _
		$AVEC_SEPARATEURS, _
		"(\1)[\2]", _ ; ATTENTION !!
		0))

; supprime les caractres en double
$c = "11,222,33,4444"
MsgBox(0, $c, remplaceCaracteresEnDouble($c))

; comparaison avec _ArrayUnique
$c = ""
For $i = 1 To 10000
	$c &= Random(1, 100, 1) & ","
Next
; recherche avec recupere_uniques_doublons
MsgBox(0, "", "Appuyez sur ""Ok"" pour lancer la recherche avec recupere_uniques_doublons.")
$t = TimerInit()
$aResultat = recupere_uniques_doublons( _
		$c, _
		",", _
		"[\d]+", _
		"[\d,]+", _
		$UNIQUES, _
		$SANS_SEPARATEURS, _
		3, _
		1)
$t2 = TimerDiff($t)
MsgBox(0, "Temps avec recupere_uniques_doublons", $t2)
_ArraySort($aResultat)
_ArrayDisplay($aResultat)
; recherche avec _ArrayUnique
MsgBox(0, "", "Appuyez sur ""Ok"" pour lancer la recherche avec _ArrayUnique" & @CRLF & "(Risque d'tre un peu plus long...)")
$a = StringSplit($c, ",")
_ArrayDelete($a, 0)
$t = TimerInit()
$aResultat2 = _ArrayUnique($a)
$t2 = TimerDiff($t)
MsgBox(0, "Temps avec _ArrayUnique", $t2)
_ArrayDelete($aResultat2, 0)
_ArrayDelete($aResultat2, UBound($aResultat2) - 1)
_ArraySort($aResultat2)
_ArrayDisplay($aResultat2)
; vrifie que les rsultats correspondent
If UBound($aResultat) <> UBound($aResultat2) Then MsgBox(0, "", "Arfff !!!")
For $i = 0 To UBound($aResultat) - 1
	If $aResultat[$i] <> $aResultat2[$i] Then MsgBox(0, "", "C'est la catastrophe !!!")
Next
#EndRegion EXEMPLE

Func recupere_uniques_doublons( _
		Const $chaine, _ ; chane dans laquelle faire la recherche
		Const $separateurs = ",", _ ; dans la chane "1, 2, 3", $separateurs sera une virgule et un espace (, )
		Const $contenuAChercher = "[^,]+", _ ; n'importe quel caractre sauf virgule
		Const $contenuPresentDansLaChaine = ".+", _ ; la chane "1,2,3" contient des chiffres et des virgules donc $contenuPresentDansLaChaine pourrait contenir [\d,]+ (notez que l'on peu laisser ".+" (tous les caractres) mais c'est moins optimis dans ce cas)
		Const $typeElements = 0, _ ; rechercher : 0 = lments uniques ; 1 = lments en double
		Const $avecSeparateurs = False, _ ; inclure les sparateurs dans la rcupration des lments ?
		Const $flag = 3, _ ; voir doc. StringRegExp
		Const $offset = 1) ; voir doc. StringRegExp
	Local $expReg, $suffixe

	If $typeElements = 0 Then ; s'il faut chercher les lments uniques
		$suffixe = "!"
	ElseIf $typeElements = 1 Then ; lments en double
		$suffixe = "="
	Else ; mauvais paramtre
		Return SetError(1, "", "")
	EndIf

	If $avecSeparateurs = False Then ; ne pas inclure les sparateurs dans le rsultat
		$expReg = _
				"(?<=" & $separateurs & "|^)" & _
				"(?>(" & $contenuAChercher & "))" & _
				"(?" & $suffixe & $separateurs & "\1" & _
				"(?=" & $separateurs & "|$)" & _
				"|" & $separateurs & $contenuPresentDansLaChaine & "?" & $separateurs & "\1" & _
				"(?=" & $separateurs & "|$))"
	ElseIf $avecSeparateurs = True Then ; inclure les sparateurs dans le rsultat
		$expReg = _
				"(?<=" & $separateurs & "|^)" & _
				"(?>(" & $contenuAChercher & ")(?:(" & $separateurs & ")|$))" & _
				"(?" & $suffixe & "\1(?=" & $separateurs & "|$)|" & _
				$contenuPresentDansLaChaine & "?" & $separateurs & "\1(?=" & $separateurs & "|$))"
	Else
		Return SetError(2, "", "")
	EndIf

	Local $r = StringRegExp($chaine, $expReg, $flag, $offset)
	If @error Then Return SetError(3, @error, "")
	Return $r
EndFunc   ;==>recupere_uniques_doublons

; IMPORTANT :	- quand $avecSeparateurs = true et quand $typeElements = 1, alors \1 contient l'lment et \2 contient le sparateur
; 				- quand $avecSeparateurs = true et quand $typeElements = 0, alors \1 contient le sparateur et \2 contient l'lment
Func remplace_uniques_doublons( _
		Const $chaine, _
		Const $separateurs = ",", _
		Const $contenuAChercher = "[^,]+", _
		Const $contenuPresentDansLaChaine = ".+", _
		Const $typeElements = 1, _
		Const $avecSeparateurs = True, _
		Const $chaineDeRemplacement = "", _ ; voir "replace" dans la doc. de StringRegExpReplace
		Const $nbRemplacements = 0) ; voir "count" dans la doc. de StringRegExpReplace
	Local $expReg, $suffixe

	If $typeElements = 0 Then ; s'il faut chercher les lments uniques
		$suffixe = "!"
	ElseIf $typeElements = 1 Then ; lments en double
		$suffixe = "="
	Else ; mauvais paramtre
		Return SetError(1, "", "")
	EndIf

	If $avecSeparateurs = False Then ; ne pas inclure les sparateurs dans le rsultat
		$expReg = _
				"(?<=" & $separateurs & "|^)" & _
				"(?>(" & $contenuAChercher & "))" & _
				"(?" & $suffixe & $separateurs & "\1" & _
				"(?=" & $separateurs & "|$)" & "|" & _
				$separateurs & $contenuPresentDansLaChaine & "?" & $separateurs & "\1" & _
				"(?=" & $separateurs & "|$))"
	ElseIf $avecSeparateurs = True Then ; inclure les sparateurs dans le rsultat
		If $suffixe = "!" Then
			$expReg = _
					"(?:(" & $separateurs & ")|^)" & _
					"(?>(" & $contenuAChercher & "))" & _
					"(?!" & $separateurs & "\2(?=" & $separateurs & "|$)|" & _
					$contenuPresentDansLaChaine & "?" & $separateurs & "\2(?=" & $separateurs & "|$))"
		Else
			$expReg = _
					"(?<=" & $separateurs & "|^)" & _
					"(?>(" & $contenuAChercher & "))(?:(" & $separateurs & ")|$)" & _
					"(?=" & "\1(?=" & $separateurs & "|$)|" & _
					$contenuPresentDansLaChaine & "?" & $separateurs & "\1(?=" & $separateurs & "|$))"
		EndIf
	Else
		Return SetError(2, "", "")
	EndIf

	Local $r = StringRegExpReplace($chaine, $expReg, $chaineDeRemplacement, $nbRemplacements)
	If @error Then Return SetError(3, @error, "")
	Return $r
EndFunc   ;==>remplace_uniques_doublons

Func remplaceCaracteresEnDouble(Const $chaine, Const $chaineARemplacer = ".", Const $chaineDeRemplacement = "\1", Const $nbRemplacements = 0)
	Local Const $expReg = '(' & $chaineARemplacer & ')\1+'

	$r = StringRegExpReplace($chaine, $expReg, $chaineDeRemplacement, $nbRemplacements)
	If @error Then Return SetError(@error, "", "")
	Return $r
EndFunc   ;==>remplaceCaracteresEnDouble
